--
-- The ZIG configuration utility.
-- Version 1.0
--
-- ZIG v1.0 990814
-- Copyright 1999, Jacob Hammond.
-- Webpage: http://surf.to/zig
--          or http://www2.crosswinds.net/~zig/index.htm
-- E-mail:  zig@crosswinds.net
--

include file.e
include get.e
include image.e
include graphics.e
include wildcard.e

include zutil.e
include zgfx.e

-- redefine box constants for no ASCII-redef
UL = 218 UR = 191 LL = 192 LR = 217 V = 179 H = 196

if graphics_mode(3) then
    puts(1, "There was an error initializing Mode 3 (80x25x16)!")
    abort(1)
end if

atom k

egachars()

cursor(NO_CURSOR)

sequence background, config

config = {}

background = {
"۲                      ",
" İ              ",
"    ıı            ",
"    ı  Ĳ    Ĳ            ",
"     ı               ",
"   İİ             ",
"  İ  İ            ",
"   ı  ı            ",
"    ı İĲ İ            ",
"    Ĳ   ıı   ı            ",
"    ı Ĳ    Ĳ            ",
"    İıı            ",
"  ıİ ı            ",
"                    ",
"                      ",
"                        ",
"                        ",
"                        ",
"                        ",
"                      ",
"                    ",
"                      ",
"                        ",
"                        "}

procedure wipe()
    bk_color(0)
    for z = 1 to 80 by 2 do
        for a = 1 to 25 do
            position(a, z)
            puts(1, ' ')
        end for
    end for
    for z = 1 to 25 by 2 do
        for a = 1 to 80 do
            position(z, a)
            puts(1, ' ')
        end for
    end for
end procedure

procedure end_prog(atom save)
    atom f

    k = time() + .25
    while k > time() do    
    end while
    while get_key() != -1 do    
    end while
    
    wipe()

    text_color(7)
    bk_color(0)
    clear_screen()
    cursor(UNDERLINE_CURSOR)

    if save then
        f = open("zconfig.inf", "w")
        print(f, config)
        close(f)
        puts(1, "The configuration was written succesfully.\n\n")
    else
        puts(1, "The configuration was not updated.\n\n")
    end if
    
    abort(0)
end procedure

text_color(1)
for z = 1 to 24 do
    puts(1, background[z])
end for

text_color(14)
bk_color(3)
position(25, 1)
puts(1, repeat(32, 79))
position(25, 1)
puts(1, " The ZIG Configuration Utility v1.0")

k = time() + .5
while k > time() do    
end while
while get_key() != -1 do    
end while
         
cursor(UNDERLINE_CURSOR)

Box(5, 5, 20, 75, 1, "ZIG Configuration")

position(7, 7) text_color(14)
puts(1, "If you are unsure about something, then just press Enter.")

position(9, 7) text_color(15)
puts(1, "Do you want digital sound support [Y/n]?")
position(10, 7) text_color(14)
puts(1, "This requires a sound card that is, at the minumum, compatible") 
position(11, 7)
puts(1, "with a Sound Blaster 1.xx. If you want stereo sound at 44,100hZ,")
position(12, 7)
puts(1, "you'll need a SB16 or compatible.")

position(9, 48)
k = upper(wait_key())
if k != 'N' then
    config = append(config, 1)
    position(9, 7) text_color(15)
    puts(1, "Do you want digital sound support? Yes  ")
else config = append(config, 0)
    position(9, 7) text_color(15)
    puts(1, "Do you want digital sound support? No   ")
    end_prog(1)
end if

for z = 10 to 12 do
    position(z, 7)
    puts(1, repeat(32, 66))
end for

position(11, 7) text_color(14)
puts(1, "Frequencies are:")
position(12, 7)
puts(1, "\t1:\t11,025hZ\t\t2:\t22,050hZ")
position(13, 7)
puts(1, "\t3:\t33,075hZ\t\t4:\t44,100hZ")
position(14, 7)
puts(1, "Higher frequencies sound better, but take up more processor time.")
position(10, 7) text_color(15)
puts(1, "Which sound frequency do you want (1/2/3/4) [4]? ")

k = wait_key()
if k != '1' and k != '2' and k != '3' and k != '4' then
    k = '4'
end if

if k = '1' then config = append(config, "11025")
elsif k = '2' then config = append(config, "22050")
elsif k = '3' then config = append(config, "33075")
elsif k = '4' then config = append(config, "44100")
end if

for z = 10 to 14 do
    position(z, 7)
    puts(1, repeat(32, 66))
end for

position(10, 7) text_color(15)
puts(1, "Which sound frequency do you want? " & config[2][1..2] & "," & config[2][3..5] & "hZ")

position(11, 7)
puts(1, "Stereo sound [Y/n]? ")
k = upper(wait_key())
if k != 'N' then
    config = append(config, 1)
    position(11, 7) text_color(15)
    puts(1, "Stereo sound? Yes   ")
else config = append(config, 0)
    position(11, 7) text_color(15)
    puts(1, "Stereo sound? No    ")
end if

position(13, 7)
puts(1, "Save this configuration [Y/n]? ")
k = upper(wait_key())
position(13, 7)
if k = 'N' then
    puts(1, "Save this configuration? No   ")
    end_prog(0)
else 
    puts(1, "Save this configuration? Yes  ")
    end_prog(1)
end if

