-- zsidebar.e
-- ZIG sidebar display functions (no specifics)

include wildcard.e

include zgfx.e
include zutil.e

global constant
    -- Sidebar button hilight (SB_HLITE1 for c03, SB_HLITE2 for c07)
    SB_HLITE1 = 16, SB_HLITE2 = 17,

    -- Constants for SB_Input()
    SBI_FILENAME = 1, SBI_NUMBER = 2, SBI_ANYSTR = 3


global procedure SB_Clear()
    display_text_image({1, 61}, repeat({32,31,32,31,32,31,32,31,32,31,32,31,32,31,32,31,32,31,32,31,32,31,32,31,32,31,32,31,32,31,32,31,32,31,32,31,32,31,32,31}, 25))
end procedure

global procedure SB_Text(atom X, atom C, sequence Text)
    if C = SB_HLITE1 then
        text_color(0) bk_color(3)
    elsif C = SB_HLITE2 then
        text_color(0) bk_color(7)
    else
        text_color(C) bk_color(1)
    end if
    
    position(X, 62)
    puts(1, Text)
end procedure

global procedure SB_CText(atom X, atom C, sequence Text)
    if C = SB_HLITE1 then
        text_color(0) bk_color(3)
    elsif C = SB_HLITE2 then
        text_color(0) bk_color(7)
    else
        text_color(C) bk_color(1)
    end if
    
    position(X, 62 + (9 - (length(Text) / 2)))
    puts(1, Text)
    
end procedure

global procedure SB_BtnText(atom X, atom C, sequence Text)
    SB_Text(X, 14, Text)
    text_color(0)
    bk_color(C)
    position(X, 62)
    if find(' ', Text[2..length(Text)]) then
        puts(1, Text[1..find(' ', Text[2..length(Text)]) + 1])
    end if
end procedure

global function SB_Input(atom TypeOf, atom Line, sequence Prompt, atom Max)
    atom Pos, Key
    sequence Ext, Inp, SS
    
    SS = SaveScreen()

    Inp = {}
    Pos = 1
    
    if TypeOf = SBI_FILENAME then
        Ext = "." & Prompt[length(Prompt) - 2..length(Prompt)]
        Prompt = Prompt[1..length(Prompt) - 3]
        Max = 8
    else Ext = {}
    end if
    
    if TypeOf = SBI_ANYSTR and Max > 18 then Max = 18 end if
    
    position(Line, 62)
    text_color(14)
    bk_color(1)
    puts(1, Prompt)
    position(Line + 1, 62)
    text_color(15)
    bk_color(0)
    puts(1, repeat(32, Max))
    
    if TypeOf = SBI_FILENAME then
        position(Line + 1, 70)
        puts(1, Ext)
    end if
    
    cursor(UNDERLINE_CURSOR)
    position(Line + 1, 62)
    Key = -1
    
    while Key != KEY_ESC and Key != KEY_CR do
        Key = get_key()
        if TypeOf = SBI_FILENAME then
            if upper(Key) != Key or lower(Key) != Key then
                if length(Inp) < Max then
                    Key = upper(Key)
                    Inp = append(Inp, Key)
                    position(Line + 1, 62)
                    puts(1, Inp)
                end if
            end if                
        else
            if Key > 31 and Key < 127 and length(Inp) < Max then                
                Inp = append(Inp, Key)
                position(Line + 1, 62)
                puts(1, Inp)
            end if
        end if
        if Key = 8 then
            if length(Inp) != 0 then
                Inp = Inp[1..length(Inp) - 1]
                position(Line + 1, 62)
                puts(1, Inp & " ")
                position(Line + 1, 62)
                puts(1, Inp)
            end if
        end if        
    end while
    
    cursor(NO_CURSOR)
    ResScreen(SS)

    return Inp
end function

